﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SMT4_D_Edit
{
    public partial class mainForm : Form
    {
        List<byte[]> ignoreList = new List<byte[]>();
        public mainForm()
        {
            InitializeComponent();
            clearAll();
            for (byte i = 0; i < 0x11; i++)
            {
                byte[] ignoredItem = { i, 0 };
                ignoreList.Add(ignoredItem);
            }
        }
        List<int> numberList = new List<int>();
        List<int> lengthList = new List<int>();
        List<int> startingPositionList = new List<int>();
        List<byte[]> sentenceByteList = new List<byte[]>();
        List<bool> isFaulty = new List<bool>();

        OpenFileDialog OFD = new OpenFileDialog();
        private int length;
        private int startingPosition;
        private int temp1;
        private int number;

        private void openToolStripMenuItem_Click_1(object sender, EventArgs e)
        {
            OFD.Filter = "|*.mbm";
            if (OFD.ShowDialog() == DialogResult.OK)
            {
                clearAll();
                BinaryReader br = new BinaryReader(File.OpenRead(OFD.FileName));
                int i = 0x20;
                temp1 = 0;
                while (temp1 == 0)
                {
                    number++;
                    length = 0;
                    startingPosition = 0;
                    temp1 = 0;
                    for (int ni = 7; ni >= 4; ni--)
                    {
                        br.BaseStream.Position = i + ni;
                        length += br.ReadByte() * (int)(Math.Pow(0x100,ni - 4));
                    }
                    
                    for (int ni = 11; ni >= 8; ni--)
                    {
                        br.BaseStream.Position = i + ni;
                        startingPosition += br.ReadByte() * (int)(Math.Pow(0x100, ni - 8));
                    }
                    if (length != 0 && startingPosition != 0)
                    {
                        numberList.Add(number);
                        lengthList.Add(length);
                        startingPositionList.Add(startingPosition);
                    }

                    for (int ni = 12; ni <= 15; ni++)
                    {
                        br.BaseStream.Position = i + ni + 16 ;
                        temp1 += br.ReadByte();
                    }

                    i = i + 0x10;
                }
                br.Close();
                reprintSS();
                sentenceSelector.SelectedIndex = 0;
            }
        }

        private void sentenceSelector_SelectedIndexChanged(object sender, EventArgs e)
        {
            for (int i = 0; i < lengthList.Count; i++)
            {
                if (sentenceSelector.SelectedIndex == i)
                {

                    sentenceBox.Text = Encoding.GetEncoding(932).GetString(sentenceByteList[i]);
                    positionValueInt.Text = startingPositionList[i].ToString();
                    lengthValueInt.Text = lengthList[i].ToString();
                    newLengthValueInt.Text = sentenceByteList[i].Length.ToString();
                    positionValue.Text = startingPositionList[i].ToString("X");
                    lengthValue.Text = lengthList[i].ToString("X");
                    newLengthValue.Text = sentenceByteList[i].Length.ToString("X");
                }
            }
        }

        private void sentenceBox_TextChanged(object sender, EventArgs e)
        {
            byte[] bytes = Encoding.GetEncoding(932).GetBytes(sentenceBox.Text);
            newLengthValueInt.Text = bytes.Length.ToString();
            newLengthValue.Text = bytes.Length.ToString("x");
        }

        private void applyButton_Click(object sender, EventArgs e)
        {
            if (isFaulty[sentenceSelector.SelectedIndex])
            {
                DialogResult dialogResult = MessageBox.Show("This text has placeholders and\nisn't going to convert properly\nContinue?", "Warning", MessageBoxButtons.YesNo);
                if (dialogResult == DialogResult.Yes)
                {
                    applyChanges(sentenceSelector.SelectedIndex);
                }
                else if (dialogResult == DialogResult.No)
                {
                    //do something else
                }
            }
            else
            {
                applyChanges(sentenceSelector.SelectedIndex);
            }
        }

        private void reprintSS()
        {
            sentenceByteList.Clear();
            for (int i = 0; i < lengthList.Count; i++)
            {
                isFaulty.Add(false);
                BinaryReader br = new BinaryReader(File.OpenRead(OFD.FileName));
                sentenceSelector.Items.Add(numberList[i].ToString("X") + " : " + lengthList[i].ToString("X") + " & " + startingPositionList[i].ToString("X"));
                //Console.WriteLine(numberList[i].ToString("X") + " : " + lengthList[i].ToString("X") + " & " + startingPositionList[i].ToString("X"));
                br.BaseStream.Position = startingPositionList[i];
                sentenceByteList.Add(br.ReadBytes(lengthList[i]));
                for (int j=0;j<lengthList[i];j=j+2)
                {
                    br.BaseStream.Position = startingPositionList[i] + j;
                    for(int k=0; k<ignoreList.Count; k++)
                        if (string.Join(",", br.ReadBytes(2)) == string.Join(",", ignoreList[k]))
                        {
                            byte[] oldArray = sentenceByteList[i];
                            sentenceByteList[i] = Replace(oldArray, ignoreList[k], new byte[] { 0xFF, 0xFF });
                            isFaultySentence(i, true);
                            Console.WriteLine(",", sentenceByteList[i]);
                        }
                }
                br.Close();
            }
        }
        
        private void clearAll()
        {
            number = -1;
            sentenceSelector.Items.Clear();
            lengthList.Clear();
            startingPositionList.Clear();
            sentenceBox.Text = "";
            sentenceSelector.Text = "";
            positionValue.Text = "";
            lengthValue.Text = "";
            newLengthValue.Text = "";
            positionValueInt.Text = "";
            lengthValueInt.Text = "";
            newLengthValueInt.Text = "";
        }

        private static byte[] Replace(byte[] input, byte[] pattern, byte[] replacement)
        {
            if (pattern.Length == 0)
            {
                return input;
            }

            List<byte> result = new List<byte>();

            int i;

            for (i = 0; i <= input.Length - pattern.Length; i++)
            {
                bool foundMatch = true;
                for (int j = 0; j < pattern.Length; j++)
                {
                    if (input[i + j] != pattern[j])
                    {
                        foundMatch = false;
                        break;
                    }
                }

                if (foundMatch)
                {
                    result.AddRange(replacement);
                    i += pattern.Length - 1;
                }
                else
                {
                    result.Add(input[i]);
                }
            }

            for (; i < input.Length; i++)
            {
                result.Add(input[i]);
            }

            return result.ToArray();
        }

        private void ReplaceData(int position, byte[] data)
        {
            using (Stream stream = File.OpenWrite(OFD.FileName))
            {
                stream.Position = position;
                stream.Write(data, 0, data.Length);
                stream.Close();
            }
        }

        private void isFaultySentence(int index, bool state)
        {
            isFaulty[index] = state;
        }
        
        private void applyChanges(int index)
        {
            if (lengthValue.Text == newLengthValue.Text)
            {
                lengthAndPosition(index);
                byte[] newText = Encoding.GetEncoding(932).GetBytes(sentenceBox.Text);
                ReplaceData(startingPositionList[index], newText);
            }
            else
            {
                BinaryReader br = new BinaryReader(File.OpenRead(OFD.FileName));
                int EndOfList = sentenceSelector.Items.Count - 1;
                br.BaseStream.Position = startingPositionList[index] + lengthList[index];
                byte[] restOfBlock = br.ReadBytes(startingPositionList[EndOfList] + lengthList[EndOfList]);
                br.Close();
                byte[] newText = Encoding.GetEncoding(932).GetBytes(sentenceBox.Text);
                lengthAndPosition(index);
                ReplaceData(startingPositionList[index], newText);
                ReplaceData(startingPositionList[index] + lengthList[index], restOfBlock);
            }
        }  

        private void lengthAndPosition(int index)
        {
            if (index != -1)
            {
                byte[] bytes = Encoding.GetEncoding(932).GetBytes(sentenceBox.Text);
                for (int i = index + 1; i < lengthList.Count; i++)
                {
                    startingPositionList[i] += bytes.Length - lengthList[index];
                    byte[] newPosition = BitConverter.GetBytes(startingPositionList[i]);
                    ReplaceData(0x20 + 0x8 + numberList[i] * 0x10, newPosition);
                }
                lengthList[index] = bytes.Length;
                byte[] newLength = BitConverter.GetBytes(bytes.Length);
                ReplaceData(0x20 + 0x4 + numberList[index] * 0x10, newLength);

                sentenceByteList[index] = Encoding.GetEncoding(932).GetBytes(sentenceBox.Text);
            }
        }
         
    }
}
